//Call to load up the correct Hessian library.
#include <dlfcn.h>
#include <stdio.h>
#include "ErrorHandler.h"
#include <stdlib.h>

class tree;
class Realmatrix;
class Factmatrix;
class sequence;
class params;
class precalc;
class mspace;

static void *lib=NULL;

extern int NumCodons;
extern int NumCodonsSq;

extern void (*sthss)(tree &T,const Factmatrix &f,const sequence *data,const params & p,int i, long double *siteliks,const precalc &x,mspace &mem);

extern void (*mkmtrcs)(const Realmatrix& M,const Realmatrix& N,const long double *d,const int *part,long double *mat,long double *mat2,long double *mat3,long double *mat4);

void closelib(){
  if(lib!=NULL){
    dlclose(lib);
    lib=NULL;
  };
};

void setNumCodons(int n){
  NumCodons=n;
  NumCodonsSq=NumCodons*NumCodons;
  char filename[16];//As long as no matrix of size 10000 or more.
  sprintf(filename,"libCode%d.so",n);
  if(lib!=NULL){
    dlclose(lib);
  };
  lib=dlopen(filename,RTLD_NOW);
  if(dlerror()){
    info(filename);
    fatalError("Could not open hessian library. Aborting!");
  };
  atexit(closelib);
  void *addr=dlsym(lib,"sthss");
  if(dlerror()){
    fatalError("Could not open resolve symbol \"sthss\". Aborting!");
  };
  sthss=*(void(**)(tree &,const Factmatrix &,const sequence *,const params &,int, long double *,const precalc &,mspace &))addr;
  addr=dlsym(lib,"mkmtrcs");
  if(dlerror()){
    fatalError("Could not open resolve symbol \"mkmtrcs\". Aborting!");
  };
  mkmtrcs=*(void(**)(const Realmatrix& M,const Realmatrix& N,const long double *d,const int *part,long double *mat,long double *mat2,long double *mat3,long double *mat4))addr;
};
