#include<iostream>
#include<fstream>
using namespace std;

#include "Matrix.h"
#include "Parameters.h"
#include "CommandLine.h"
#include "ErrorHandler.h"

void testundopars(int *sel,ifstream& Qmat){
  params p;
  params::orthmats();
  variable *rec=vars.seektag("-initpars");
  if(rec!=NULL){
    char *x=new char[50+strlen(*(char **)rec->value)];
    sprintf(x,"Reading parameters from file \"%s\".",*(char**)rec->value);
    info(x,msgcode(1,0));
    ifstream in;
    setifstream(*(char**)rec->value,&in);
    if(!in.good()){
      sprintf(x,"Could not open initial parameter file \"%s\"",*(char**)rec->value);
      recoverableError(x);//should give file menu.
    };
    p.readpars(in);
    in.close();
    delete[] x;
  }else{
    Realmatrix Q(Qmat);
    p.getpars(Q);
  };
  p.normalise();
  long double *tc=p.truepars();
  for(int i=0;i<params::numpars;i++){
    cout<<*(tc+i)<<" ";
  };
  cout<<"\n\n";
  int np=params::numpars;
  Realmatrix *oldx=new Realmatrix[np];
  for(int i=0;i<np;i++){
    *(oldx+i)=*(params::XX+i);
  };
  p.selectpars(sel);
  p.undoselect(sel,np);
  tc=p.truepars();
  for(int i=0;i<params::numpars;i++){
    cout<<*(tc+i)<<" ";
  };
  cout<<"\n\n";
  for(int i=0;i<np;i++){
    long double err=0;
    for(int j=0;j<NumCodonsSq;j++){
      long double df=*((oldx+i)->entries+j)-*((params::XX+i)->entries+j);
      if(df<0){
	df=-df;
      };
      if(df>err){
	err=df;
      };
    };
    cout<<err<<"\n";
  };
};
